﻿Public Class UpdateVB
    Public url As String
    Public strUsername As String
    Public strPassword As String
    Public bool_showUI As Boolean
    Public timer As New Timer
    Public updatetextfileurlstring As String



    Private Sub UpdateVB_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Control.CheckForIllegalCrossThreadCalls = False
        btn_download.Visible = False
        progress.Visible = False

    End Sub
    Sub checkforupdate(ByVal updatetextfileurl As String, ByVal currentversion As String, ByVal updaterexecutableurl As String, ByVal fileUsername As String, ByVal filePassword As String, ByVal showUI As Boolean)
        If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/version.txtdat") Then
            My.Computer.FileSystem.DeleteFile(My.Application.Info.DirectoryPath + "/version.txtdat")
        End If
        If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/update.exe") Then
            My.Computer.FileSystem.DeleteFile(My.Application.Info.DirectoryPath + "/update.exe")
        End If
        Try
            My.Computer.Network.DownloadFile(updatetextfileurl, My.Application.Info.DirectoryPath + "/version.txtdat")
            If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/version.txtdat") Then
                Dim reader As New System.IO.StreamReader(My.Application.Info.DirectoryPath + "/version.txtdat")
                Dim read As String = reader.ReadToEnd
                reader.Close()
                If read <> currentversion Then
                    url = updaterexecutableurl
                    btn_download.Visible = True

                Else
                    'Do nothing as latest version is present
                End If
            Else
                checkforupdate(updatetextfileurl, currentversion, updaterexecutableurl, fileUsername, filePassword, showUI)
            End If

        Catch ex As Exception
            MsgBox("Error with Updater, " + ex.Message)
        End Try
    End Sub
    Sub btn_click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn_download.Click
        Try
            If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/version.txtdat") Then
                My.Computer.FileSystem.DeleteFile(My.Application.Info.DirectoryPath + "/version.txtdat")
            End If
            If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/update.exe") Then
                My.Computer.FileSystem.DeleteFile(My.Application.Info.DirectoryPath + "/update.exe")
            End If
            btn_download.Visible = False
            progress.Visible = True
            downloadupdate(url, strUsername, strPassword, bool_showUI)

        Catch ex As Exception
            MsgBox("Error : " + ex.Message)
        End Try
    End Sub
    Sub downloadupdate(ByVal updaterexecuteableurl As String, ByVal username As String, ByVal password As String, ByVal showUI As Boolean)
        Try
            My.Computer.Network.DownloadFile(updaterexecuteableurl, My.Application.Info.DirectoryPath + "/update.exe", username, password, showUI, 99999999, True)
            If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/update.exe") Then

                url = updaterexecuteableurl
                strUsername = username
                strPassword = password
                bool_showUI = showUI

                timer.Interval = 10
                progress.Maximum = 1000
                timer.Enabled = True
                timer.Start()
                AddHandler timer.Tick, AddressOf timer_tick
            Else
                downloadupdate(updaterexecuteableurl, username, password, showUI)
            End If

        Catch ex As Exception
            MsgBox("Error with Downloading Update, " + ex.Message)
        End Try
    End Sub
    Sub timer_tick(ByVal sender As Object, ByVal e As System.EventArgs)

        Try
            Do Until progress.Value = 1000
                progress.Value = progress.Value + 1
            Loop
            If progress.Value = 1000 Then


                If My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath + "/update.exe") Then
                    Shell(My.Application.Info.DirectoryPath + "/update.exe")
                    timer.Stop()
                    timer.Enabled = False
                    Exit Sub
                Else
                    downloadupdate(url, strUsername, strPassword, bool_showUI)
                End If
            End If
        Catch ex As Exception
            If ex.Message.Contains("not") Then
                Shell(My.Application.Info.DirectoryPath + "/update.exe")
                timer.Stop()
                timer.Enabled = False
            End If
        End Try
    End Sub

    Private Sub btn_download_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_download.Click

    End Sub

    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork

    End Sub
End Class

